#define LOG_TAG "ANYCHAT"

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <stddef.h>
#include <wchar.h>
#include <stdint.h>
#include <android/log.h>

typedef unsigned int DWORD;
typedef char CHAR;

#define MEDIACODEC_EXPORTS
#include "MediaCodecBase.h"


/**
 *	HuaWei Codec Context for AnyChat
 */
typedef struct HUAWEI_CODEC_CONTEXT 
{
	void*	lpCodec;


}HUAWEI_CODEC_CONTEXT, *LPHUAWEI_CODEC_CONTEXT;


// ȡϢ
DWORD MediaCodec_GetLibraryInfo(DWORD* dwCapability, DWORD* dwMainVer, DWORD* dwSubVer, CHAR* lpCompileTime, DWORD dwBufLen)
{
	// 汾Ϣ
	*dwMainVer = 1;
	*dwSubVer = 0;
	
	// ʱ
	if(dwBufLen && lpCompileTime)
		snprintf(lpCompileTime,dwBufLen,"%s %s",__DATE__,__TIME__);

	*dwCapability = MEDIACODEC_CAPABILITY_VIDEOENCODEC | MEDIACODEC_CAPABILITY_VIDEODECODEC;
	// ϲӦãһӲ
	*dwCapability |= MEDIACODEC_CAPABILITY_HARDWARECODEC;
	return 0;
}
// ȡϢ
DWORD MediaCodec_GetCodecInfo(DWORD dwCodecType, DWORD* dwCodecId, CHAR* lpCodecName, DWORD dwBufLen)
{
	DWORD ret = -1;
	if(dwCodecType & MEDIACODEC_CAPABILITY_VIDEOENCODEC)
	{
		*dwCodecId = MEDIA_CODEC_ID_H264;
		if(lpCodecName && dwBufLen)
		{
			strcpy(lpCodecName, "HuaWei H.264(AVC) Encoder");
		}
		ret = 0;
	}
	else if(dwCodecType & MEDIACODEC_CAPABILITY_VIDEODECODEC)
	{
		*dwCodecId = MEDIA_CODEC_ID_H264;
		if(lpCodecName && dwBufLen)
			strcpy(lpCodecName, "HuaWei H.264(AVC) Decoder");
		ret = 0;
	}
	return ret;
}

// ͷſԴ
DWORD MediaCodec_Release(void)
{
	return 0;
}


// Ƶ
DWORD MediaCodec_VideoCodec_InitEncoder(MediaCodecContext* lpContext)
{
	struct HUAWEI_CODEC_CONTEXT* lpHuaWeiCodecContext =  (struct HUAWEI_CODEC_CONTEXT*)malloc(sizeof(struct HUAWEI_CODEC_CONTEXT));
	if(!lpHuaWeiCodecContext)
		return -1;
	// ȡʵ
	
	//......
	
	lpContext->lpPrivateData = lpHuaWeiCodecContext;

	return -1;			// 򿪳ɹҪreturn 0;
}

/**
 *	Ƶб
 */
DWORD MediaCodec_VideoCodec_Encode(MediaCodecContext* lpContext, MediaPacket* InPacket, MediaPacket* OutPacket)
{
	struct HUAWEI_CODEC_CONTEXT* lpHuaWeiCodecContext =  (struct HUAWEI_CODEC_CONTEXT*)lpContext->lpPrivateData;
	if(!lpHuaWeiCodecContext)
		return -1;
	
	
	return -1;			// ɹҪreturn 0;
}
// رƵ
DWORD MediaCodec_VideoCodec_CloseEncoder(MediaCodecContext* lpContext)
{
	struct HUAWEI_CODEC_CONTEXT* lpHuaWeiCodecContext =  (struct HUAWEI_CODEC_CONTEXT*)lpContext->lpPrivateData;
	if(lpHuaWeiCodecContext)
	{
		if(lpHuaWeiCodecContext->lpCodec)
		{
	
		}
		free(lpHuaWeiCodecContext);
	}
	lpContext->lpPrivateData = NULL;
	return 0;
}

// Ƶ
DWORD MediaCodec_VideoCodec_InitDecoder(MediaCodecContext* lpContext)
{ 
	struct HUAWEI_CODEC_CONTEXT* lpHuaWeiCodecContext =  (struct HUAWEI_CODEC_CONTEXT*)malloc(sizeof(struct HUAWEI_CODEC_CONTEXT));
	if(!lpHuaWeiCodecContext)
		return -1;
	// ȡʵ
	
	// ......
	
	lpContext->lpPrivateData = lpHuaWeiCodecContext;
	return -1;			// 򿪳ɹҪreturn 0;
}

// Ƶн
DWORD MediaCodec_VideoCodec_Decode(MediaCodecContext* lpContext, MediaPacket* InPacket, MediaPacket* OutPacket)
{
	struct HUAWEI_CODEC_CONTEXT* lpHuaWeiCodecContext =  (struct HUAWEI_CODEC_CONTEXT*)lpContext->lpPrivateData;
	if(!lpHuaWeiCodecContext || !lpHuaWeiCodecContext->lpCodec)
		return -1;

	return -1;			// ɹҪreturn 0;
}
// رƵ
DWORD MediaCodec_VideoCodec_CloseDecoder(MediaCodecContext* lpContext)
{
	struct HUAWEI_CODEC_CONTEXT* lpHuaWeiCodecContext =  (struct HUAWEI_CODEC_CONTEXT*)lpContext->lpPrivateData;
	if(lpHuaWeiCodecContext)
	{
		if(lpHuaWeiCodecContext->lpCodec)
		{

		}
		free(lpHuaWeiCodecContext);
	}
	lpContext->lpPrivateData = NULL;
	return 0;
}



