#ifndef ANYCHAT_MEDIACODEC_BASE_H_INCLUDED
#define ANYCHAT_MEDIACODEC_BASE_H_INCLUDED

#include "pixfmt.h"

#pragma pack(push)
#pragma pack(1)


#if defined(WIN32)
#	if defined(MEDIACODEC_EXPORTS)
#		define MEDIACODEC_API extern "C" __declspec(dllexport)
#	else
#		define MEDIACODEC_API extern "C" __declspec(dllimport)
#	endif
#else
#	if defined(MEDIACODEC_EXPORTS)
#		define MEDIACODEC_API extern "C"
#	else
#		define MEDIACODEC_API
#	endif
#endif

// 
#define MEDIACODEC_CAPABILITY_AUDIOENCODEC	0x00000001		///< Ƶ
#define MEDIACODEC_CAPABILITY_AUDIODECODEC	0x00000002		///< Ƶ
#define MEDIACODEC_CAPABILITY_VIDEOENCODEC	0x00000004		///< Ƶ
#define MEDIACODEC_CAPABILITY_VIDEODECODEC	0x00000008		///< Ƶ

#define MEDIACODEC_CAPABILITY_YUV420SPINPUT		0x00000100	///< Ƶ֧YUV420SP
#define MEDIACODEC_CAPABILITY_YUV420SPOUTPUT	0x00000200	///< ƵΪYUV420SP
#define MEDIACODEC_CAPABILITY_DIRECTRENDER		0x00000400	///< ֱ֧ƵʾӲȾ
#define MEDIACODEC_CAPABILITY_HARDWARECODEC		0x00000800	///< Ӳ

// ܱ־
#define MEDIACODEC_FLAGS_KEYFRAME			0x00000001		///< ؼ֡־
#define MEDIACODEC_FLAGS_WANTSPSPPS			0x00000002		///< ϲӦôSPSPPS־Ƶʹ
#define MEDIACODEC_FLAGS_NEEDREINIT			0x00000200		///< Ҫ³ʼCodec

#define MEDIACODEC_MAXCODECNAME				50

// ID
enum MEDIA_CODEC_ID {
	MEDIA_CODEC_ID_NONE = 0,

	/* video codecs */
	MEDIA_CODEC_ID_H264,
	MEDIA_CODEC_ID_MJPEG,

	/* audio codecs */
	MEDIA_CODEC_ID_AMR_NB = 10,
	MEDIA_CODEC_ID_AMR_WB,
	MEDIA_CODEC_ID_MP3,
	MEDIA_CODEC_ID_AAC,
	MEDIA_CODEC_ID_MP2,
	MEDIA_CODEC_ID_CELT,
	MEDIA_CODEC_ID_SPEEX,

	/* user define codecs*/
	MEDIA_CODEC_ID_USERSTART = 100,			///< ûԶʼID
};



// Ƶݰṹ
typedef struct MediaPacket {
	CHAR	*lpData;
	DWORD	dwSize;
	DWORD	dwFlags;
	DWORD	dwTimeStamp;
}MediaPacket,*LPMediaPacket;

// ľṹ
typedef struct MediaCodecContext {
	DWORD	cbSize;				///< ṹС
	DWORD	dwCodecId;			///< ID
	DWORD	dwFlags;			///< ر־
	CHAR	szCodecName[MEDIACODEC_MAXCODECNAME];	///< 

	// ˽
	void*	lpPrivateData;		///< ˽ָ

	// Ƶֲ
	DWORD	dwChannels;			///< Ƶͨ
	DWORD	dwSamplesPerSec;	///< Ƶ
	DWORD	dwBitsPerSample;	///< Ƶλ
	DWORD	dwFrameSize;		///< Ƶ֡

	// Ƶ
	DWORD	dwWidth;			///< Ƶ
	DWORD	dwHeight;			///< Ƶ߶
	DWORD	dwFrameRate;		///< ֡
	DWORD	dwGopSize;			///< ؼ֡
	AC_PIX_FMT	PixFmt;			///< Ƶ֡ʽ

	// 
	DWORD	dwBitrate;			///< Ŀ
	DWORD	dwQuality;			///< 
	DWORD	dwPreset;			///< Ԥ

	// ʾ
	void*	lpGlobalContext;	///< ȫֻAndroidΪJavaVM*
	void*	lpSuface;			///< ʾ
	
	DWORD	reserved[20];		///< 
}MediaCodecContext;


// ȡϢ
MEDIACODEC_API DWORD MediaCodec_GetLibraryInfo(DWORD* dwCapability, DWORD* dwMainVer, DWORD* dwSubVer, CHAR* lpCompileTime, DWORD dwBufLen);
// ȡϢ
MEDIACODEC_API DWORD MediaCodec_GetCodecInfo(DWORD dwCodecType, DWORD* dwCodecId, CHAR* lpCodecName, DWORD dwBufLen);
// ͷſԴ
MEDIACODEC_API DWORD MediaCodec_Release(void);

// Ƶ
MEDIACODEC_API DWORD MediaCodec_AudioCodec_InitEncoder(MediaCodecContext* lpContext);
// Ƶб
MEDIACODEC_API DWORD MediaCodec_AudioCodec_Encode(MediaCodecContext* lpContext, MediaPacket *InPacket, MediaPacket* OutPacket);
// رƵ
MEDIACODEC_API DWORD MediaCodec_AudioCodec_CloseEncoder(MediaCodecContext* lpContext);

// Ƶ
MEDIACODEC_API DWORD MediaCodec_AudioCodec_InitDecoder(MediaCodecContext* lpContext);
// Ƶн
MEDIACODEC_API DWORD MediaCodec_AudioCodec_Decode(MediaCodecContext* lpContext, MediaPacket *InPacket, MediaPacket* OutPacket);
// رƵ
MEDIACODEC_API DWORD MediaCodec_AudioCodec_CloseDecoder(MediaCodecContext* lpContext);

// Ƶ
MEDIACODEC_API DWORD MediaCodec_VideoCodec_InitEncoder(MediaCodecContext* lpContext);
// Ƶб
MEDIACODEC_API DWORD MediaCodec_VideoCodec_Encode(MediaCodecContext* lpContext, MediaPacket *InPacket, MediaPacket* OutPacket);
// رƵ
MEDIACODEC_API DWORD MediaCodec_VideoCodec_CloseEncoder(MediaCodecContext* lpContext);

// Ƶ
MEDIACODEC_API DWORD MediaCodec_VideoCodec_InitDecoder(MediaCodecContext* lpContext);
// Ƶн
MEDIACODEC_API DWORD MediaCodec_VideoCodec_Decode(MediaCodecContext* lpContext, MediaPacket *InPacket, MediaPacket* OutPacket);
// رƵ
MEDIACODEC_API DWORD MediaCodec_VideoCodec_CloseDecoder(MediaCodecContext* lpContext);







#pragma pack(pop)
#endif // ANYCHAT_MEDIACODEC_BASE_H_INCLUDED




